Manuals									{#manuals}
===============
[TOC]

**Manuals for the C# API are a work in progress while the API is still in flux. They will be available in version 1.0!**

 - Getting started
  - Creating a project
  - Importing resources
  - Adding objects to scene
  - Adding components
  - Custom scripts
  - Playing the game
  - Building the game
 - Windows
  - Overview
  - Project
  - Library
  - Inspector
  - Scene
  - Hierarchy
  - Game
  - Log
 - Resources
  - Importing resources
  - Import options
 - Level creation
  - Scene object
  - Scene tools
  - Components
  - Prefab
  - Saving scene
 - Graphics
  - Camera
  - Light
  - Renderable
  - Shader
  - Material
  - Mesh
  - Texture
 - Physics
  - Colliders
  - Triggers
  - Rigidbody
  - Character controller
  - Physics mesh
  - Physics material
  - Joints
 - GUI
  - Font
  - GUISkin
  - GUIWidget
  - Localization
 - Building/publishing your game
 - Editor settings
 - Scripting
  - ScriptCode
  - Custom components
  - Log window
  - Inspector
  - Playing in editor
  - Scene loading
  - Prefabs
  - Graphics
   - Camera
   - Render targets
   - Renderable
   - Light
   - Texture
    - PixelUtility
   - Mesh
   - Material
   - Shader
  - Input
   - Raw input
   - Virtual input
   - Input configuration
  - GUI
   - Global GUI
   - GUI widgets
   - GUI panel
   - GUI layout
   - GUI elements
   - GUI skin
   - Localization (StringTable)
   - Font
  - Physics
   - Colliders
   - Triggers
   - Rigidbody
   - Character controller
   - Physics mesh
   - Physics material
   - Joints
   - Scene queries
   - Global options
  - Resources
   - General
   - Creating custom resources
  - Shaders
   - Simple shader example
   - BSLFX syntax
  - Utility
   - Time
   - Logging
   - Math
   - Cursor
  - Editor
   - Creating custom editor windows
   - Creating custom inspectors
   - Creating custom gizmos
   - Creating custom handles
   - Editor GUI elements
   - ProjectLibrary
   - Attributes
   - Undo/Redo
   - Selection
   - Editor input
   - Drag and drop
   - Serialization
    - General
    - Serialized properties
   - Helper windows
    - Dialog box
    - Progress bar
    - Color picker